package com.logicbig.example;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ObjectReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class ExampleMain2 {
    public static void main(String[] args) throws IOException {
        String inputJson = "{\"name\":\"Jake\",\"salary\":3000"
                + ",\"address\":{\"street\":\"101 Blue Dr\",\"city\":\"White Smoke\"}}";
        System.out.println("input json: " + inputJson);

        Map<String, Object> existingMap = new HashMap<>(Map
                .of("name", "John", "dept", "Dev", "salary", 1000, "phone", "222-222-222", "address",
                        new HashMap<>(Map.of("street", "101 Blue Dr", "city", "SunBridge", "zipCode", "23456"))));
        System.out.println("existingMap: " + existingMap);
        System.out.println("existing map hashCode: " + System.identityHashCode(existingMap));
        System.out.println("existing nested map hash code: "+System.identityHashCode(existingMap.get("address")));

        ObjectMapper objectMapper = new ObjectMapper();
        ObjectReader objectReader = objectMapper.readerForUpdating(existingMap);
        Map updatedMap = objectReader.readValue(inputJson);
        System.out.println("updated map: " + updatedMap);
        System.out.println("updated map hashCode: " + System.identityHashCode(updatedMap));
        System.out.println("updated nested map hash code: "+System.identityHashCode(updatedMap.get("address")));
    }
}